local AceOO = AceLibrary("AceOO-2.0")

ShakedownAddonBase = AceOO.Class("AceDebug-2.0")

-- this is an abstract class, that all addon plugins should inherit from
ShakedownAddonBase.virtual = true

-- data members
ShakedownAddonBase.prototype.addonName = ""
ShakedownAddonBase.prototype.enabled = true
ShakedownAddonBase.prototype.activated = false

-- table to hold each of the addons
SDAddons = {}

-- constructor
function ShakedownAddonBase.prototype:init(addonName)
    
    ShakedownAddonBase.super.prototype.init(self)
    
    -- set the addon plugin's name
    self.addonName = addonName
    
    -- put this addon in the table
    table.insert(SDAddons, self)
end

function ShakedownAddonBase.prototype:Activate()
    self:Debug("Activating shakedown for "..tostring(self))
    self.activated = true
end

function ShakedownAddonBase.prototype:Deactivate()
    self:Debug("Deactivating shakedown for "..tostring(self))
    self.activated = false
end

-- output the name of the addon on tostring calls
function ShakedownAddonBase.prototype:ToString()
    return self.addonName
end

-- compare function, so that we can sort by addon name
function ShakedownAddonBase.prototype:IsLessThan(other)
    return (self.addonName < other.addonName)
end

-- turn debugging on or off
function ShakedownAddonBase.prototype:SetDebug(enabled)
    self:SetDebugging(enabled)
end
