local AceOO = AceLibrary("AceOO-2.0")

Addon = AceOO.Class(ShakedownAddonBase, "Metrognome-2.0")

Addon.prototype.msgFrequency = 2
Addon.prototype.barFrequency = 21

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "DBM")
end

function Addon.prototype:Activate()

    Addon.super.prototype.Activate(self)

    -- attempt to LOD
    if not IsAddOnLoaded("DBM_GUI") then
        LoadAddOn("DBM_GUI")
    end

    -- check existence
    if not DBMGUI_VERSION then return end
    
    -- show a message now
    self:ShowMessage()
    
    -- show bar now
    self:ShowBar()

    --schedule repeating messages and bars
    self:UnregisterMetro("DBMShakedownMessage")
    self:RegisterMetro("DBMShakedownMessage", self.ShowMessage, self.msgFrequency, self)
    self:StartMetro("DBMShakedownMessage")
    
    self:UnregisterMetro("DBMShakedownBar")
    self:RegisterMetro("DBMShakedownBar", self.ShowBar, self.barFrequency, self)
    self:StartMetro("DBMShakedownBar")
end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)

    -- check existence
    if not DBMGUI_VERSION then return end
    
    -- hide the dragbar
    DBM_StatusBarTimerDrag:Hide()
    
    -- kill the scheduled messages and bars
    self:UnregisterMetro("DBMShakedownMessage")
    self:UnregisterMetro("DBMShakedownBar")

end

function Addon.prototype:ShowMessage()

    RaidWarningFrames_AddLocalMessages(DBMGUI_RAIDWARNING_EXAMPLE)
    DBM.HasAggro("Monstar")
    
end

function Addon.prototype:ShowBar()

    DBM_StatusBarTimerDrag:Show()
    
end

-- create the instance of this class
local thisAddon = Addon:new()
