local AceOO = AceLibrary("AceOO-2.0")

Addon = AceOO.Class(ShakedownAddonBase, "Metrognome-2.0")

Addon.colour = {r=1, g=1, b=1}

-- constructor
function Addon.prototype:init()
    Addon.super.prototype.init(self, "SCT")
end

function Addon.prototype:Activate()

    Addon.super.prototype.Activate(self)

    -- attempt to LOD SCT and SCTD options
    if not IsAddOnLoaded("sct_options") then
        LoadAddOn("sct_options")
        if SCT then
            --Hook SCT ShowExample
            if (not SCTD:IsHooked(SCT, "ShowExample")) then
                SCTD:Hook(SCT, "ShowExample");
            end
            --Hook SCT ShowTest
            if (not SCTD:IsHooked(SCT, "ShowTest")) then
                SCTD:Hook(SCT, "ShowTest");
            end
        end
    end
    
    -- check existence
    if not SCT then return end
    
    -- display something now
    self:Display()
    
    -- schedule a display every second
    self:UnregisterMetro("SCTShakedownDisplay")
    self:RegisterMetro("SCTShakedownDisplay", self.Display, 1, self)
    self:StartMetro("SCTShakedownDisplay")

end

function Addon.prototype:Deactivate()

    Addon.super.prototype.Deactivate(self)

    -- stop display scheduling
    self:UnregisterMetro("SCTShakedownDisplay")

end

function Addon.prototype:Display()

   -- display some crits
    SCT:DisplayText(SCT.LOCALS.EXAMPLE, self.colour, true, "damage", SCT.FRAME1)
    SCT:DisplayText(SCT.LOCALS.EXAMPLE2, self.colour, true, "damage", SCT.FRAME2)
    if SCTD then
        SCT:DisplayText(SCTD.LOCALS.EXAMPLE, self.colour, true, "damage", SCT.FRAME3)
    end

    -- display regular
    SCT:ShowTest()
    
end

-- create the instance of this class
local thisAddon = Addon:new()